;StringMaths functions
;Author: Shantanu Gadgil
;Enjoy!

;SM_DecimalStringToDword
;returns the converted value of the string in eax
SM_DecimalStringToDword	proc	pszString:LPCTSTR
	LOCAL	dwLocalAnswer:DWORD
	push	ebx
	push	edx
	push	esi
	
	xor	eax,eax
	mov	esi,pszString
	mov	al,[esi]
	sub	al,30h
	
	mov	dwLocalAnswer,eax
	.while	byte ptr [esi+1] != 0
		xor	edx,edx
		mov	eax,dwLocalAnswer
		mov	ebx,10
		mul	ebx
		
		inc	esi
		
		xor	edx,edx
		mov	dl,[esi]
		sub	dl,30h
		add	eax,edx
		
		mov	dwLocalAnswer,eax
	.endw
	
	pop	esi
	pop	edx
	pop	ebx
	ret

SM_DecimalStringToDword endp

;SM_DecimalStringToInt
;returns the converted number at location of pNumber
;supports signed numbers
;if the 'bSigned' is specified as TRUE, first character of the string
;must be be '+' or '-'
SM_DecimalStringToInt	proc	pszString:LPCTSTR, pNumber:DWORD, bSigned:BOOL
	LOCAL	dwAnswer:DWORD
	LOCAL	dwReturnValue:DWORD
	LOCAL	bPositive:BOOL
	
	push	ebx
	push	ecx
	push	edx
	push	esi
	
	mov	dwReturnValue, FALSE
	mov	esi,pszString
	.if	bSigned == TRUE
		.if	byte ptr [esi] == '+'
			mov	bPositive, TRUE
			mov	dwReturnValue, TRUE
			inc	esi 
		.elseif	byte ptr [esi] == '-'
			mov	bPositive, FALSE
			mov	dwReturnValue, TRUE
			inc	esi
		.else
			;error, invalid leading symbol
			jmp	@f
		.endif
	.endif
	xor	eax, eax
	mov	al, [esi]
	sub	al, 30h
	mov	dwAnswer, eax	;store first digit as number
	
	xor	ecx, ecx
	.while	ecx < 10	;4,294,967,295 == 10 digits
		.break	.if	byte ptr [esi+1] == 0
		
		xor	edx, edx
		mov	eax, dwAnswer
		mov	ebx, 10
		mul	ebx
		
		inc	esi
		
		xor	edx,edx
		mov	dl,[esi]
		sub	dl,30h
		add	eax,edx
		
		mov	dwAnswer, eax
		inc	ecx
	.endw
	mov	ebx, pNumber
	mov	eax, dwAnswer
	.if	bPositive == FALSE
		neg	eax
	.endif
	mov	[ebx], eax
	
	mov	dwReturnValue, TRUE
@@:
	mov	eax, dwReturnValue
	pop	esi
	pop	edx
	pop	ecx
	pop	ebx
	ret

SM_DecimalStringToInt endp